MODE2(1)

NAME

mode2 - Show pulse/space length or decoded input from infrared drivers.

SYNOPSIS

mode2 --driver <driver> --device <device> [other options]

mode2 --raw --device <device> [other options]

DESCRIPTION

The main purpose of this program is to check operation of your home-brew LIRC receiver hardware and to see the IR waveform of the remote controller without an expensive oscilloscope. Very useful for debugging also in situations you just need to verify configuration.

mode2 will simply print pulse and space lengths to stdout for drivers supporting LIRC_MODE_MODE2. For drivers supporting LIRC_MODE_LIRCCODE such as TV-cards and the irman driver writes the decoded, integer values.

When given the correct driver mode2 should always work. Without a driver, the --raw option should always work for /dev/lirc* devices. At the time of writing, usb devices also work in most cases. However, since it is tricky to get the path to the usb device, such ones are normally best accessed using a driver.

OPTIONS

-d --device=device
    Read from given device.

-H --driver=driver
    Use given driver.

-m --mode=mode
    Write pulse/space data as raw config files. Does not affect LIRCCODE drivers.

-s --scope=time
    Enable 'scope like display with time us per char. Does not affect lirccode drivers.

-k --keep-root
    Don't drop root privileges after opening device. See RUNNING AS ROOT.

-g --gap=time
    Treat spaces longer than time as the gap. Time is in microseconds.

-r --raw
    Access device directly. This is primarely intended to be used with kernel drivers i.e., when accessing /dev/lirc* devices. Using other devices might work, but is in general undefined.

-A --driver-options=key:value[|key:value...]
    Set driver-specific option named key to given value.

-U --plugindir=directory
    Load drivers from directory. See DRIVER LOADING.

-h --help
    Display usage summary.

-v --version
    Display version.

RUNNING AS ROOT
In many cases mode2 needs to run as root to access devices not available to regular users. On the other hand, running as root creates problems such as log files owned by root, security concerns etc.

In order to cope with this, mode2 by default drops root privileges after opening the input device. This support is based on that root permissions are accquired using sudo(1) e. g., using
        $ sudo mode2 --raw /dev/lirc0
If not using sudo, the same behaviour could be accomplished using the SUDO_USER environment variable e. g.,
        # SUDO_USER=$LOGNAME mode2 --raw /dev/lirc0
The --keep-root option will make mode2 to keep root privileges for the complete run.

DRIVER LOADING
Drivers are loaded dynamically. The search path used for this is determined by (falling priority):

-   The --plugindir option.

-   The 'plugindir' entry in the [lircd] section of the lirc_options.conf file.

-   The environment variable LIRC_PLUGINDIR.

-   A hardcoded default (usually /usr/lib[64]/lirc/plugins).

ENVIRONMENT

LIRC_LOGLEVEL
    Determines the amount of logging information. [level] can be a symbolic syslog level: 'error','warning, 'info', 'notice' or 'debug'. lirc also defines three additional levels 'trace', 'trace1' and 'trace2' which gives even more messages ('trace2' bringing the most). However, in the log these messages are marked as 'debug'.

    The level can also be an integer in the range 3 (almost no messages) to 10.

FILES

~/.cache/mode2.log
    Debug output. Setting the XDG_CACHE_HOME environment variable relocates this file to $XDG_CACHE_HOME/mode2.log

SEE ALSO
xmode2(1)
lirc(4) The documentation for lirc is maintained as html pages. They are located under html/ in the documentation directory.